com.genesyslab.wfm8.API.service.forecast810

## Interface WFMForecastService810Soap

- All Superinterfaces:
    java.rmi.Remote

      public interface WFMForecastService810Soap
      extends java.rmi.Remote

  An accurate forecast is critical in producing an optimal schedule for the contact center workforce. Genesys's unique forecasting model combines historical CTI data with data from the ACD to provide a more accurate forecast across all types of interactions. Data is collected on a real-time basis, so forecasts reflect the most recent activity trends and demands for services. WFM Forecast Service is a part of the WFM Server component.

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addScenarioActivity(int scenarioId, java.util.List<FrcActivity> activities)` Adds scenario Activities.
    `void` | `addTemplateActivities(int templateId, java.util.List<FrcActivity> activities)` Method modifies existing template and adds specified Activities.
    `java.lang.String` | `adjustForecastInformation(int scenarioId, java.util.List<java.lang.Integer> BUIDArray, java.util.List<java.lang.Integer> siteIDArray, java.util.List<FrcActivity> activities, java.util.List<java.lang.Integer> types, double start, double end, java.util.List<java.lang.Integer> weekdays, double percentage)` Adjust forecast data values for requested target by given percentage.
    `java.lang.String` | `applyOverheadTemplate(int scenarioID, double start, double end, java.util.List<FrcActivityStateGroup> targetActivityStateGroups, java.util.List<java.lang.Integer> typeIDArray, java.util.List<FrcTemplateData> templateData)` Applies existing template data to specified overhead for selected activity and state group
    `java.lang.String` | `asyncGetForecastInformation(int scenarioID, int target, int targetID, java.util.List<java.lang.Integer> types, double start, double end, int branchSelection, java.util.List<java.lang.Integer> granularities, int request)` Starts an asynchronous request for forecast information for the specified period and specified target.
    `java.lang.String` | `asyncSplitPredictedData(int scenarioId, java.util.List<FrcActivity> sourceActivity, java.util.List<FrcActivity> targetActivities, double start, double end, java.util.List<FrcActivityPeriodParameters> periodParameters, boolean keepAHT, boolean useAllActivities, boolean frcSaveSplitResults, boolean considerPlannedItems)` Method takes specified source Multi-site Activities Interaction Volume (and Average Handle Time, if the parameter is specified) data and splits using [splitting] algorithm between specified Activities for the specified date range.
    `java.lang.String` | `buildPredictedDataBasedOnConstant(int scenarioId, java.util.List<FrcActivity> activities, java.util.List<java.lang.Integer> types, double start, double end, double growthRate, double IVValue, double AHTValue, boolean frcSaveBuildResults)` Method takes specified value and fills in all periods in the specified date range for the requested data types.
    `java.lang.String` | `buildPredictedDataBasedOnHistory(int scenarioId, java.util.List<FrcActivity> activities, java.util.List<java.lang.Integer> types, double start, double end, double historyStart, double historyEnd, double growthRate, java.util.List<FrcTemplateData> overrideData, boolean frcSaveBuildResults)` Method takes specified values (historical data or data overridden by specified values) and fills in corresponding periods (template values or provided specific dates) in specified date range for the requested data types.
    `java.lang.String` | `buildPredictedDataBasedOnTemplate(int scenarioId, java.util.List<FrcActivity> activities, java.util.List<java.lang.Integer> types, double start, double end, double growthRate, java.util.List<FrcTemplateData> templateData, boolean frcSaveBuildResults)` Method takes specified values (usually a combination of values from templates) and fills in corresponding periods (template values are provided for weekdays, not specific dates) in the specified date range for requested data types.
    `java.lang.String` | `buildPredictedDataUseMethod(int scenarioId, java.util.List<FrcActivity> activities, java.util.List<java.lang.Integer> types, double start, double end, int method, double historyStart, double historyEnd, double growthRate, java.util.List<FrcTemplateData> data, java.util.List<FrcActivityEvents> eventsArray, boolean frcSaveBuildResults, boolean useAllEvents)` Method takes the specified parameters and uses a method from the WFM Prediction Library to create data in the specified date range for the requested data types.
    `java.lang.String` | `buildPredictedDataUseMethodWithHistoricalPeriods(int scenarioId, java.util.List<FrcActivity> activities, java.util.List<java.lang.Integer> types, double start, double end, int method, java.util.List<FrcInformationPeriod> periodsArray, double growthRate, java.util.List<FrcTemplateData> data, java.util.List<FrcActivityEvents> eventsArray, boolean frcSaveBuildResults, boolean useAllEvents)`
    `java.lang.String` | `calculateInteractionQueue(int scenarioID, double start, double end, CfgActivityFilter activityFilter, double initialQueue)`
    `java.lang.String` | `calculateOverlayImpactVector(FrcOverlay overlay, double historyStart, double historyEnd, java.util.List<FrcTemplateData> data, java.util.List<FrcActivityEvents> eventsArray, boolean useAllApplicableEvents)` Calculates impact vector for specified overlay based on requested information.
    `java.lang.String` | `calculateStaffingRequirementData(int scenarioId, java.util.List<FrcActivity> targetActivities, java.util.List<java.lang.Integer> types, double start, double end, int method, java.util.List<FrcActivityPeriodParameters> periodParameters, java.util.List<FrcActivityStaffingDataParameters> parametersArray, java.util.List<FrcActivityStaffingDataObjectives> objectivesArray, java.util.List<FrcActivityTemplateData> templateDataArray, java.util.List<java.lang.Integer> groupIDArray, boolean frcSaveBuildResults)` Method takes Activity parameters according to method used to calculate data in the specified date range for requested data types, and saves data for the specified scenario and return request identifier (asynchronous).
    `java.lang.String` | `copyScenarioActivityShrinkageData(int scenarioID, double start, double end, FrcActivityStateGroup sourceActivityStateGroup, java.util.List<FrcActivityStateGroup> targetActivityStateGroups)` Copies shrinkage data from source activity and state group to target activities and state groups
    `void` | `createOverlay(FrcOverlay overlay)` Creates overlay with provided data.
    `void` | `createOverlayEvent(FrcOverlayEvent event)` Creates (overlay) event with provided attributes.
    `int` | `createScenario(java.lang.String name, java.lang.String comments, int type, java.util.List<FrcActivity> activities, double start, double end)` Gets attributes (name, type etc.), specified Activities, requested period (start and end), and saves to the new scenario.
    `int` | `createTemplate(int type, java.lang.String name, int parentType, int parentId, double start, double end, java.util.List<FrcActivity> activities, double initialValue, int basedOnTemplate)` Creates new template under "parent".
    `void` | `deleteForecastInformation(int scenarioId, java.util.List<FrcActivity> activities, double start, double end)` Deletes specified scenario Activities information for requested date range.
    `void` | `deleteOverlay(int overlayID)` Deletes specified overlay (and all related events, overlay activities).
    `void` | `deleteOverlayEvent(int eventID)` Deletes specified (overlay) event.
    `void` | `deleteScenario(int scenarioId)` Deletes specified scenario information and related Activities information.
    `void` | `deleteScenarioActivity(int scenarioId, java.util.List<FrcActivity> activities)` Deletes scenario Activities.
    `java.lang.String` | `deleteScenarioActivityStateGroups(int scenarioID, double start, double end, java.util.List<FrcActivityStateGroup> activityStateGroups)` Delete activity and state group shrinkage data
    `void` | `deleteTemplate(java.util.List<java.lang.Integer> templates)` Deletes all specified templates.
    `void` | `deleteTemplateActivities(int templateId, java.util.List<FrcActivity> activities)` Modifies existing template and removes specified Activities.
    `java.lang.String` | `distributePeriodForecastTotal(int scenarioID, java.util.List<java.lang.Integer> BUIDArray, java.util.List<java.lang.Integer> siteIDArray, java.util.List<FrcActivity> activities, java.util.List<java.lang.Integer> types, double start, double end, java.util.List<java.lang.Integer> weekdays, double totalValue)` Distributes forecast data total over specified period for requested target.
    `void` | `editOverlay(FrcOverlay overlay)` Updates existing overlay with provided data.
    `void` | `editOverlayEvent(FrcOverlayEvent event)` Updates attributes of specified (overlay) event.
    `java.lang.String` | `findHistoricalDataAnomalies(java.util.List<FrcActivity> activities, int dataType, double historyStart, double historyEnd, java.util.List<FrcTemplateData> data, java.util.List<FrcActivityEvents> eventsArray, boolean useAllApplicableEvents, double threshold, int granularity)` Searches for unusual deviations periods in historical data for specified activity and data period.
    `int` | `findScenarioInSnapshot(java.lang.String snapshotId, java.lang.String name, int startIndex)` Allows location of a specific forecast scenario inside the existing snapshot.
    `java.util.List<FrcActivityHistoricalInformationIndicators>` | `getActivityHistoricalInformationIndicators(java.util.List<FrcActivity> activities, java.util.List<java.lang.Integer> types, double start, double end, int request)` Returns historical data indicators for requested Activities and historical data date ranges for specified period.
    `java.util.List<FrcActivityOverlay>` | `getActivityOverlays(java.util.List<FrcActivity> activities, double start, double end)` Returns array of overlays and events assigned to Activity(ies) for the specified period.
    `java.util.List<FrcActivityOverlay>` | `getActivityOverlaysEx(java.util.List<FrcActivity> activities, double start, double end)` Returns array of overlays and events assigned to all specified Activity(ies) for specified period.
    `java.util.List<FrcActivityAnomalies>` | `getAnomaliesResult(java.lang.String asyncRequestID)` Retrieves result previously made request to find historical data anomalies.
    `java.util.List<FrcTargetForecastInformation>` | `getAsyncRequestForecastInformation(java.lang.String asyncRequestID)` Gets an asynchronous request result of forecast information for the specified period and specified target.
    `java.util.List<FrcActivityEvents>` | `getForecastActivityEvents(int scenarioId, java.util.List<FrcActivity> activities, double start, double end)` Returns forecast Activity events for specified period.
    `java.util.List<FrcActivityEvents>` | `getForecastActivityEventsEx(int scenarioId, java.util.List<FrcActivity> activities, double start, double end)` Returns forecast events for the specified period which is associated with all specified Activities.
    `FrcActivityBuildSelection` | `getForecastActivityPredictionBuildSelection(int scenarioID, int target, int targetID)` Method returns the user selection made for the last predicted data build for the selected target (Activity or Multi-site Activity) in the scenario.
    `FrcActivityBuildSelection` | `getForecastActivityStaffingBuildSelection(int scenarioID, int target, int targetID)` Method returns the user selection made for the last staffing requirements build for the selected target (Activity or Multi-site Activity) in the scenario.
    `java.util.List<FrcTargetForecastInformation>` | `getForecastInformation(int scenarioId, int target, int targetId, java.util.List<java.lang.Integer> types, double start, double end, int timeZone, int branchSelection, int granularity, int request)` Returns requested forecast information for specified period and specified target.
    `java.util.List<FrcActivityDataIndicator>` | `getForecastInformationIndicators(int scenarioId, double start, double end, java.util.List<FrcActivity> activities)` Returns data indicators for requested scenario Activities and date period, if specified
    `java.util.List<FrcTargetForecastInformation>` | `getForecastRequestActivityData(java.lang.String requestID, int activityID, java.util.List<java.lang.Integer> types, double start, double end, int granularity)` Method returns forecast results for the specified Activity, if request completed.
    `java.util.List<FrcSplitResult>` | `getForecastSplitResult(java.lang.String asyncRequestID)` Method returns forecast data split result for the request (requested/split data).
    `java.util.List<FrcSplitResult>` | `getForecastSplitResults(java.lang.String asyncRequestID)` Method returns forecast data split result for the request (requested/split data).
    `java.util.List<FrcActivityEventsEx>` | `getForecastTargetEvents(int scenarioId, int target, int targetId, double start, double end)` Returns forecast events for the specified period which is associated with the specified target.
    `java.util.List<FrcTargetForecastInformation>` | `getHistoricalInformation(int target, int targetId, java.util.List<java.lang.Integer> types, double start, double end, int granularity)` Returns historical data for specified period and specified Activities.
    `FrcHistoricalShortInformation` | `getHistoricalShortInformation()` Returns basic historical data (start/end, Activities).
    `java.util.List<java.lang.Double>` | `getImpactVectorResult(java.lang.String asyncRequestID)` Retrieves result of previously made request to calculate overlay impact vector.
    `java.util.List<FrcOverlay>` | `getOverlays(java.util.List<java.lang.Integer> BUIDArray, java.util.List<java.lang.Integer> siteIDArray, java.util.List<java.lang.Integer> overlayIDArray, double start, double end, boolean includeEvents, boolean includeActivities)` Returns array of requested overlays (and events, activities is requested) for specified period.
    `java.util.List<FrcScenarioInformation>` | `getScenario(java.util.List<java.lang.Integer> scenarioIDs)` Retrieves a scenario by means of an identifier.
    `java.util.List<CfgActivityShort>` | `getScenarioActivityConfiguration(int scenarioId, java.util.List<java.lang.Integer> sites, int sortMode, boolean sortAscending)` Get forecast scenario Activity configuration information.
    `java.util.List<FrcActivityStateGroup>` | `getScenarioActivityStateGroups(int scenarioID, double start, double end, CfgActivityFilter activityFilter)` Returns activity and state groups which have shrinkage data
    `java.util.List<CfgBUShort>` | `getScenarioBUConfiguration(int scenarioId, int sortMode, boolean sortAscending)` Get forecast scenario Business Unit configuration information.
    `java.util.List<FrcScenarioInformation>` | `getScenarioFromSnapshot(java.lang.String snapshotId, int first, int last)` Retrieves the specified number of scenarios from the existing snapshot.
    `java.util.List<CfgSiteShort>` | `getScenarioSiteConfiguration(int scenarioId, java.util.List<java.lang.Integer> bUnits, int sortMode, boolean sortAscending)` Get forecast scenario Site configuration information.
    `java.util.List<CfgActivityShort>` | `getScenarioToVirtualAssignedActivityConfiguration(int scenarioId, java.util.List<java.lang.Integer> virtualActivities, int sortMode, boolean sortAscending)` Get forecast scenario Activity associated with specified Multi-site Activity(ies) configuration information.
    `java.util.List<CfgVirtualActivityShort>` | `getScenarioVirtualActivityConfiguration(int scenarioId, java.util.List<java.lang.Integer> bUnits, int sortMode, boolean sortAscending)` Get forecast scenario Virtual Activity configuration information.
    `FrcTemplate` | `getTemplate(int templateId, int request)` Returns template's header, activities, and data values.
    `java.util.List<FrcActivity>` | `getTemplateActivities(int templateId)` Returns all template's Activities.
    `java.util.List<FrcData>` | `getTemplateData(int templateId)` Returns template's data values.
    `java.util.List<FrcTemplateHeader>` | `getTemplatesList(java.util.List<java.lang.Integer> BUs, java.util.List<java.lang.Integer> sites, java.util.List<java.lang.Integer> types)` Returns all templates for the specified target.
    `java.util.List<FrcTemplateHeader>` | `getTemplatesListEx(java.util.List<java.lang.Integer> BUs, java.util.List<java.lang.Integer> sites, java.util.List<java.lang.Integer> types, java.util.List<FrcActivity> activities)` Returns templates associated with specified Activities.
    `java.util.List<FrcInformationPeriod>` | `getUserHistoricalPeriods(int scenarioID)`
    `FrcScenarioSnapshot` | `openScenarioSnapshot(int ownership, java.util.List<java.lang.Integer> scenarioIDs, java.util.List<java.lang.Integer> types, java.util.List<java.lang.Integer> statuses, double start, double end, int sortMode, boolean sortAscending)` Opens a snapshot of forecast scenarios based on specified filtering parameters.
    `java.lang.String` | `publishForecast(java.util.List<FrcActivity> activities, int sourceScenarioId, double sourceStartDate, double sourceEndDate, int targetScenarioId, double targetStartDate, double targetEndDate)` Publishes requested Activity forecast information from the forecast scenario to the master forecast, or from the master to the forecast scenario, or from one forecast scenario to another forecast scenario.
    `java.lang.String` | `publishSelectedForecast(java.util.List<FrcActivity> activities, int sourceScenarioID, double sourceStartDate, double sourceEndDate, int targetScenarioID, double targetStartDate, double targetEndDate, java.util.List<java.lang.Integer> selectedForecastCategories)` Publishes requested Activity selected categories forecast information from the forecast scenario to the master forecast, or from the master to the forecast scenario, or from one forecast scenario to another forecast scenario.
    `long` | `readScenarioDBTimestamp(int scenarioId)` Retrieves the scenario timestamp.
    `java.lang.String` | `saveForecastRequestData(java.lang.String asyncRequestToSaveID)` Method should be used to save results of forecast build request.
    `int` | `saveHistoricalDataAsTemplate(int type, java.lang.String name, int parentType, int parentId, double start, double end, double templateStart, double templateEnd, java.util.List<FrcActivity> activities, java.util.List<FrcActivity> sourceActivities)` Saves historical Interaction Volume or Average Handle Time data as template.
    `int` | `saveStaffingDataAsTemplate(java.lang.String name, int parentType, int parentId, double start, double end, java.util.List<FrcActivity> activities, int sourceScenarioId, java.util.List<FrcActivity> sourceActivities)` Saves specified scenario Activities Staffing requirements as template for requested Activities.
    `java.lang.String` | `setForecastInformation(int scenarioId, java.util.List<FrcActivityForecastInformation> information)` Updates scenario Activity information.
    `java.lang.String` | `setForecastPeriodParameters(int scenarioID, java.util.List<FrcActivityPeriodParameters> periodParameters)` Sets forecast parameters for specified activity and period
    `java.lang.String` | `setForecastShrinkage(int scenarioID, java.util.List<FrcShrinkageData> shrinkageDataArray)` Sets shrinkage data for activity and state group
    `java.lang.String` | `setOvertimeRequirement(java.util.List<FrcOvertimeData> overtimeDataArray)` Sets overtime requirement for activity
    `void` | `setScenarioComments(int scenarioId, java.lang.String comments)` Updates/sets scenario comments.
    `void` | `setScenarioName(int scenarioId, java.lang.String name)` Updates scenario name.
    `void` | `setScenarioType(int scenarioId, int type)` Updates scenario type.
    `void` | `setTemplateData(int templateId, java.util.List<FrcData> data)` Modifies existing template and sets specified values for periods.
    `void` | `setTemplateName(int templateId, java.lang.String name)` Modifies existing template's name.
    `void` | `sortScenarioSnapshot(java.lang.String snapshotId, int sortMode, boolean sortAscending)` Allows a change to the sort order for the existing scenario snapshot.
    `java.lang.String` | `splitInteractionVolume(int scenarioID, java.util.List<FrcActivity> sourceActivity, java.util.List<FrcActivity> targetActivities, double start, double end, java.util.List<FrcActivityPeriodParameters> periodParameters, boolean keepAHT, boolean useAllActivities, boolean frcSaveSplitResults, boolean considerPlannedItems, java.util.List<FrcActivityPercentageParameters> percentageParameters)` Method takes specified source Multi-site Activities Interaction Volume (and Average Handle Time, if the parameter is specified) data and splits using [splitting] algorithm between specified Activities for the specified date range.
    `java.lang.String` | `splitStaffingDataAsync(int scenarioId, java.util.List<FrcActivity> sourceActivity, java.util.List<FrcActivity> targetActivities, double start, double end, java.util.List<FrcActivityPeriodParameters> periodParameters, java.util.List<FrcActivityStaffingDataParameters> parametersArray, boolean splitRequired, boolean useAHT, boolean frcSaveSplitResults)` Method takes specified source Multi-site Activities Calculated Staffing requirements (and Required if the parameter is specified) data and splits using [splitting] algorithm between specified Activities for the specified date range.

- - ### Method Detail

    - #### distributePeriodForecastTotal

          java.lang.String distributePeriodForecastTotal(int scenarioID,
                                                       java.util.List<java.lang.Integer> BUIDArray,
                                                       java.util.List<java.lang.Integer> siteIDArray,
                                                       java.util.List<FrcActivity> activities,
                                                       java.util.List<java.lang.Integer> types,
                                                       double start,
                                                       double end,
                                                       java.util.List<java.lang.Integer> weekdays,
                                                       double totalValue)
                                                         throws java.rmi.RemoteException

      Distributes forecast data total over specified period for requested target.
      Parameters:
        `scenarioID` - Scenario identifier, 0 - for master
        `BUIDArray` - Array of Business Unit IDs
        `siteIDArray` - Array of Site IDs
        `activities` - Array of forecast Activities
        `types` - Array of required data types
        `start` - Date range start
        `end` - Date range end
        `weekdays` - Days of week to include, empty - all days included.
        `totalValue` - Value to distribute.
      Returns:
        Async request ID
      Throws:
        `java.rmi.RemoteException`

    - #### findHistoricalDataAnomalies

          java.lang.String findHistoricalDataAnomalies(java.util.List<FrcActivity> activities,
                                                     int dataType,
                                                     double historyStart,
                                                     double historyEnd,
                                                     java.util.List<FrcTemplateData> data,
                                                     java.util.List<FrcActivityEvents> eventsArray,
                                                     boolean useAllApplicableEvents,
                                                     double threshold,
                                                     int granularity)
                                                       throws java.rmi.RemoteException

      Searches for unusual deviations periods in historical data for specified activity and data period.
      Parameters:
        `activities` - Activities data to be searched
        `dataType` - Required data type (IV and AHT supported)
        `historyStart` - Historical data start date
        `historyEnd` - Historical data end date
        `data` - Array contains data values for items (IV overlap, AHT overlap from FrcTemplateTypes) from periods when historical data should be overridden.
        `eventsArray` - Involved Events
        `useAllApplicableEvents` - Ignores events parameter and uses all applicable events
        `threshold` - Percentage of deviation
        `granularity` - Search step in minutes (60 = 1 hour, and 1440 = 1 day are supported)
      Returns:
        Request identifier
      Throws:
        `java.rmi.RemoteException`

    - #### getAnomaliesResult

          java.util.List<FrcActivityAnomalies> getAnomaliesResult(java.lang.String asyncRequestID)
                                                                  throws java.rmi.RemoteException

      Retrieves result previously made request to find historical data anomalies.
      Parameters:
        `asyncRequestID` - Request identifier
      Returns:
        Contains deviation periods for requested activities.
      Throws:
        `java.rmi.RemoteException`

    - #### calculateOverlayImpactVector

          java.lang.String calculateOverlayImpactVector(FrcOverlay overlay,
                                                      double historyStart,
                                                      double historyEnd,
                                                      java.util.List<FrcTemplateData> data,
                                                      java.util.List<FrcActivityEvents> eventsArray,
                                                      boolean useAllApplicableEvents)
                                                        throws java.rmi.RemoteException

      Calculates impact vector for specified overlay based on requested information.
      Parameters:
        `overlay` - Target overlay for which impact vector to be calculated. Overlay must contain impact unit information (hourly, daily), activity from which historical data should be used and selected overlay events.
        `historyStart` - Historical data start date
        `historyEnd` - Historical data end date
        `data` - Array contains data values for items (IV overlap, AHT overlap from FrcTemplateTypes) from periods when historical data should be overridden.
        `eventsArray` - Additional applicable events (from other overlays)
        `useAllApplicableEvents` - Ignores events parameter and uses all applicable events
      Returns:
        Request identifier
      Throws:
        `java.rmi.RemoteException`

    - #### getImpactVectorResult

          java.util.List<java.lang.Double> getImpactVectorResult(java.lang.String asyncRequestID)
                                                                 throws java.rmi.RemoteException

      Retrieves result of previously made request to calculate overlay impact vector.
      Parameters:
        `asyncRequestID` - Request identifier
      Returns:
        Impact vector values.
      Throws:
        `java.rmi.RemoteException`

    - #### getScenario

          java.util.List<FrcScenarioInformation> getScenario(java.util.List<java.lang.Integer> scenarioIDs)
                                                             throws java.rmi.RemoteException

      Retrieves a scenario by means of an identifier.
      Parameters:
        `scenarioIDs` - Scenario ID filter. Empty means "all scenarios".
      Returns:
        Contains scenario information.
      Throws:
        `java.rmi.RemoteException`

    - #### readScenarioDBTimestamp

          long readScenarioDBTimestamp(int scenarioId)
                                       throws java.rmi.RemoteException

      Retrieves the scenario timestamp.
      Parameters:
        `scenarioId` - Forecast scenario identifier
      Returns:
        Scenario timestamp
      Throws:
        `java.rmi.RemoteException`

    - #### openScenarioSnapshot

          FrcScenarioSnapshot openScenarioSnapshot(int ownership,
                                                 java.util.List<java.lang.Integer> scenarioIDs,
                                                 java.util.List<java.lang.Integer> types,
                                                 java.util.List<java.lang.Integer> statuses,
                                                 double start,
                                                 double end,
                                                 int sortMode,
                                                 boolean sortAscending)
                                                   throws java.rmi.RemoteException

      Opens a snapshot of forecast scenarios based on specified filtering parameters.
      Parameters:
        `ownership` - Allows specification of which scenarios to retrieve based on ownership
        `scenarioIDs` - Scenario ID filter. Empty means "all scenarios".
        `types` - Defines type filter. Empty means "all types".
        `statuses` - Defines status filter: protected/shared. Empty means "all statuses".
        `start` - Scenarios should fall (at least partially) within a defined date range. From version 8.1, scenario should cover specified range completely. Null means the date range is not defined.
        `end` - Date range end. Null means date range is not defined.
        `sortMode` - Scenario sort mode
        `sortAscending` - Ascending/descending
      Returns:
        Contains information about scenario snapshot
      Throws:
        `java.rmi.RemoteException`

    - #### getScenarioFromSnapshot

          java.util.List<FrcScenarioInformation> getScenarioFromSnapshot(java.lang.String snapshotId,
                                                                       int first,
                                                                       int last)
                                                                         throws java.rmi.RemoteException

      Retrieves the specified number of scenarios from the existing snapshot.
      Parameters:
        `snapshotId` - Forecast scenario snapshot identifier
        `first` - Index of first requested scenario in the snapshot
        `last` - Index of last requested scenario in the snapshot
      Returns:
        Contains list of scenario information
      Throws:
        `java.rmi.RemoteException`

    - #### sortScenarioSnapshot

          void sortScenarioSnapshot(java.lang.String snapshotId,
                                  int sortMode,
                                  boolean sortAscending)
                                    throws java.rmi.RemoteException

      Allows a change to the sort order for the existing scenario snapshot.
      Parameters:
        `snapshotId` - Forecast scenario snapshot identifier
        `sortMode` - Scenario sort mode
        `sortAscending` - Ascending/descending
      Throws:
        `java.rmi.RemoteException`

    - #### findScenarioInSnapshot

          int findScenarioInSnapshot(java.lang.String snapshotId,
                                   java.lang.String name,
                                   int startIndex)
                                     throws java.rmi.RemoteException

      Allows location of a specific forecast scenario inside the existing snapshot. Returns an index of the first scenario that has the name that matches the specified name. The specified name can be a partial string, e.g. its first few letters.
      Parameters:
        `snapshotId` - Forecast scenario snapshot ID
        `name` - A name or partial name of a scenario to locate in the snapshot
        `startIndex` - The starting index of the scenario from which to start the search
      Returns:
        Returns the index of the scenario in the snapshot. If the scenario with name specified is not found, -1 is returned.
      Throws:
        `java.rmi.RemoteException`

    - #### getScenarioBUConfiguration

          java.util.List<CfgBUShort> getScenarioBUConfiguration(int scenarioId,
                                                              int sortMode,
                                                              boolean sortAscending)
                                                                throws java.rmi.RemoteException

      Get forecast scenario Business Unit configuration information.
      Parameters:
        `scenarioId` - Scenario identifier, 0 - for master
        `sortMode` - Sort mode
        `sortAscending` - Ascending/descending
      Returns:
        Business Unit configuration information
      Throws:
        `java.rmi.RemoteException`
      See Also:
        `ECfgSortMode.BU`, `CfgBUShort`

    - #### getScenarioSiteConfiguration

          java.util.List<CfgSiteShort> getScenarioSiteConfiguration(int scenarioId,
                                                                  java.util.List<java.lang.Integer> bUnits,
                                                                  int sortMode,
                                                                  boolean sortAscending)
                                                                    throws java.rmi.RemoteException

      Get forecast scenario Site configuration information.
      Parameters:
        `scenarioId` - Scenario identifier, 0 - for master
        `bUnits` - Site filter by parent: empty - all Sites; 0 - Sites without parent BU.
        `sortMode` - Sort mode
        `sortAscending` - Ascending/descending
      Returns:
        Site configuration information
      Throws:
        `java.rmi.RemoteException`
      See Also:
        `ECfgSortMode.Site`, `CfgSiteShort`

    - #### getScenarioToVirtualAssignedActivityConfiguration

          java.util.List<CfgActivityShort> getScenarioToVirtualAssignedActivityConfiguration(int scenarioId,
                                                                                           java.util.List<java.lang.Integer> virtualActivities,
                                                                                           int sortMode,
                                                                                           boolean sortAscending)
                                                                                             throws java.rmi.RemoteException

      Get forecast scenario Activity associated with specified Multi-site Activity(ies) configuration information.
      Parameters:
        `scenarioId` - Scenario identifier
        `virtualActivities` - Multi-site Activities
        `sortMode` - Sort mode
        `sortAscending` - Ascending/descending
      Returns:
        Activity configuration information
      Throws:
        `java.rmi.RemoteException`
      See Also:
        `ECfgSortMode.Activity`, `CfgActivityShort`

    - #### getScenarioVirtualActivityConfiguration

          java.util.List<CfgVirtualActivityShort> getScenarioVirtualActivityConfiguration(int scenarioId,
                                                                                        java.util.List<java.lang.Integer> bUnits,
                                                                                        int sortMode,
                                                                                        boolean sortAscending)
                                                                                          throws java.rmi.RemoteException

      Get forecast scenario Virtual Activity configuration information.
      Parameters:
        `scenarioId` - Scenario identifier, 0 - for master
        `bUnits` - Virtual Activity filter by parent, empty - all Virtual Activities.
        `sortMode` - Sort mode
        `sortAscending` - Ascending/descending
      Returns:
        Virtual Activity configuration information
      Throws:
        `java.rmi.RemoteException`
      See Also:
        `ECfgSortMode.VirtualActivity`, `CfgVirtualActivityShort`

    - #### getScenarioActivityConfiguration

          java.util.List<CfgActivityShort> getScenarioActivityConfiguration(int scenarioId,
                                                                          java.util.List<java.lang.Integer> sites,
                                                                          int sortMode,
                                                                          boolean sortAscending)
                                                                            throws java.rmi.RemoteException

      Get forecast scenario Activity configuration information.
      Parameters:
        `scenarioId` - Scenario identifier, 0 - for master
        `sites` - Activity filter by parent, empty - all Activities.
        `sortMode` - Sort mode
        `sortAscending` - Ascending/descending
      Returns:
        Activity configuration information
      Throws:
        `java.rmi.RemoteException`
      See Also:
        `ECfgSortMode.Activity`, `CfgActivityShort`

    - #### getForecastInformationIndicators

          java.util.List<FrcActivityDataIndicator> getForecastInformationIndicators(int scenarioId,
                                                                                  double start,
                                                                                  double end,
                                                                                  java.util.List<FrcActivity> activities)
                                                                                    throws java.rmi.RemoteException

      Returns data indicators for requested scenario Activities and date period, if specified
      Parameters:
        `scenarioId` - Scenario identifier, 0 - for master
        `start` - Requested start date, null - all scenario period
        `end` - Requested end date, null - all scenario period
        `activities` - Activities filter, empty - all activities
      Returns:
        Activity data indicators
      Throws:
        `java.rmi.RemoteException`

    - #### getForecastInformation

          java.util.List<FrcTargetForecastInformation> getForecastInformation(int scenarioId,
                                                                            int target,
                                                                            int targetId,
                                                                            java.util.List<java.lang.Integer> types,
                                                                            double start,
                                                                            double end,
                                                                            int timeZone,
                                                                            int branchSelection,
                                                                            int granularity,
                                                                            int request)
                                                                              throws java.rmi.RemoteException

      Returns requested forecast information for specified period and specified target. Data can be aggregated using granularity parameter.
      Parameters:
        `scenarioId` - Scenario identifier, 0 - for master
        `target` - Target level
        `targetId` - Target identifier
        `types` - Array of required data types
        `start` - Requested start date
        `end` - Requested end date
        `timeZone` - Indicates use of time zones, 0 - ignore time zones
        `branchSelection` - Indicator specifies how target Activities must be selected: 0 - (default) Site branch; 1 - Multi-site Activity branch.
        `granularity` - Requested granularity period, in minutes. Period data is aggregated from the start to the end using the given granularity. Meaningful values: 0 - total for the whole period; 15 min (time step); 1440 (1 day); 10080 (1 week); 60480 (max long period - 6 weeks). Monthly aggregation performed on calendar-month basis (special value is -1), e.g. start Jun 15, 2003, and end Jul 15, 2003, aggregates as 2 values for the periods Jun 15, 2003 - Jun 30, 2003 and Jul 1, 2003 - Jul 15, 2003. Special values: 0 - for total value; -1 - calendar month; -10 - calendar week starts Sunday; -11 - calendar week starts Mon.; -12 - calendar week starts Tue.; -13 - calendar week starts Wed.; -14 - calendar week starts Thu.; -15 - calendar week starts Fri.; -16 - calendar week starts Sat.
        `request` - Requested information flag: 0 - all information; 1 - forecast data only; 2 - parameters only; 4 - objectives only; 8 - period parameters only; 16 - data comments. Request is a bit mask and can specify more than one information request, e.g. 5 = forecast data and objectives.
      Returns:
        Requested information values related to the scenario
      Throws:
        `java.rmi.RemoteException`

    - #### asyncGetForecastInformation

          java.lang.String asyncGetForecastInformation(int scenarioID,
                                                     int target,
                                                     int targetID,
                                                     java.util.List<java.lang.Integer> types,
                                                     double start,
                                                     double end,
                                                     int branchSelection,
                                                     java.util.List<java.lang.Integer> granularities,
                                                     int request)
                                                       throws java.rmi.RemoteException

      Starts an asynchronous request for forecast information for the specified period and specified target. Data can be aggregated using a granularity parameter.
      Parameters:
        `scenarioID` - Scenario identifier, 0 - for master
        `target` - Target level
        `targetID` - Target identifier
        `types` - Array of required data types
        `start` - Requested start date
        `end` - Requested end date
        `branchSelection` - Indicator specifies how target Activities must be selected: 0 - (default) Site branch; 1 - Multi-site Activity branch.
        `granularities` - Requested granularity period, in minutes. Period data aggregated from the start to the end using the given granularity. Meaningful values: 0 - total for the whole period; 15 min (time step); 1440 (1 day); 10080 (1 week); 60480 (max long period - 6 weeks). Monthly aggregation performed on calendar-month basis (special value is -1), e.g. start Jun 15, 2003, and end Jul 15, 2003, aggregates as 2 values for periods Jun 15, 2003 - Jun 30, 2003, and Jul 1, 2003 - Jul 15, 2003. Special values: 0 - for total value; -1 - calendar month; -10 - calendar week starts Sunday; -11 - calendar week starts Mon.; -12 - calendar week starts Tue.; -13 - calendar week starts Wed.; -14 - calendar week starts Thu.; -15 - calendar week starts Fri.; -16 - calendar week starts Sat.
        `request` - Requested information flag: 0 - all information; 1 - forecast data only; 2 - parameters only; 4 - objectives only; 8 - period parameters only; 16 - data comments. Request is a bit mask and can specify more than one information request, e.g. 5 = forecast data and objectives.
      Returns:
        Asynchronous request identifier
      Throws:
        `java.rmi.RemoteException`

    - #### getAsyncRequestForecastInformation

          java.util.List<FrcTargetForecastInformation> getAsyncRequestForecastInformation(java.lang.String asyncRequestID)
                                                                                          throws java.rmi.RemoteException

      Gets an asynchronous request result of forecast information for the specified period and specified target.
      Parameters:
        `asyncRequestID` - Asynchronous request identifier
      Returns:
        Contains requested information values related to the scenario
      Throws:
        `java.rmi.RemoteException`

    - #### getForecastSplitResults

          java.util.List<FrcSplitResult> getForecastSplitResults(java.lang.String asyncRequestID)
                                                                 throws java.rmi.RemoteException

      Method returns forecast data split result for the request (requested/split data).
      Parameters:
        `asyncRequestID` - Request identifier
      Returns:
        Split results array for each multi-site activity
      Throws:
        `java.rmi.RemoteException`

    - #### getForecastSplitResult

          java.util.List<FrcSplitResult> getForecastSplitResult(java.lang.String asyncRequestID)
                                                                throws java.rmi.RemoteException

      Method returns forecast data split result for the request (requested/split data).
      Parameters:
        `asyncRequestID` - Request identifier
      Returns:
        Split results array for each multi-site activity
      Throws:
        `java.rmi.RemoteException`

    - #### createScenario

          int createScenario(java.lang.String name,
                           java.lang.String comments,
                           int type,
                           java.util.List<FrcActivity> activities,
                           double start,
                           double end)
                             throws java.rmi.RemoteException

      Gets attributes (name, type etc.), specified Activities, requested period (start and end), and saves to the new scenario.
      Parameters:
        `name` - Created scenario name
        `comments` - Scenario comments
        `type` - Selected type of scenario (protected/shared)
        `activities` - Activities to be associated with the scenario. Scenario can be empty, without Activities.
        `start` - Requested start date
        `end` - Requested end date
      Returns:
        Created scenario identifier
      Throws:
        `java.rmi.RemoteException`

    - #### setScenarioComments

          void setScenarioComments(int scenarioId,
                                 java.lang.String comments)
                                   throws java.rmi.RemoteException

      Updates/sets scenario comments.
      Parameters:
        `scenarioId` - Scenario identifier, 0 - for master
        `comments` - Contains requested update
      Throws:
        `java.rmi.RemoteException`

    - #### setScenarioName

          void setScenarioName(int scenarioId,
                             java.lang.String name)
                               throws java.rmi.RemoteException

      Updates scenario name.
      Parameters:
        `scenarioId` - Scenario identifier, 0 - for master
        `name` - Contains requested update
      Throws:
        `java.rmi.RemoteException`

    - #### setScenarioType

          void setScenarioType(int scenarioId,
                             int type)
                               throws java.rmi.RemoteException

      Updates scenario type.
      Parameters:
        `scenarioId` - Scenario identifier, 0 - for master
        `type` - Contains requested update
      Throws:
        `java.rmi.RemoteException`

    - #### addScenarioActivity

          void addScenarioActivity(int scenarioId,
                                 java.util.List<FrcActivity> activities)
                                   throws java.rmi.RemoteException

      Adds scenario Activities.
      Parameters:
        `scenarioId` - Scenario identifier, 0 - for master
        `activities` - Contains requested update
      Throws:
        `java.rmi.RemoteException`

    - #### deleteScenarioActivity

          void deleteScenarioActivity(int scenarioId,
                                    java.util.List<FrcActivity> activities)
                                      throws java.rmi.RemoteException

      Deletes scenario Activities.
      Parameters:
        `scenarioId` - Scenario identifier
        `activities` - Contains requested update
      Throws:
        `java.rmi.RemoteException`

    - #### setForecastInformation

          java.lang.String setForecastInformation(int scenarioId,
                                                java.util.List<FrcActivityForecastInformation> information)
                                                  throws java.rmi.RemoteException

      Updates scenario Activity information. Service will take all provided information (data, comments, parameters, period parameters) from information, and will update specified scenario's Activities.
      Parameters:
        `scenarioId` - Scenario identifier, 0 - for master
        `information` - Contains updated information values related to the scenario
      Returns:
        Asynchronous request ID
      Throws:
        `java.rmi.RemoteException`

    - #### adjustForecastInformation

          java.lang.String adjustForecastInformation(int scenarioId,
                                                   java.util.List<java.lang.Integer> BUIDArray,
                                                   java.util.List<java.lang.Integer> siteIDArray,
                                                   java.util.List<FrcActivity> activities,
                                                   java.util.List<java.lang.Integer> types,
                                                   double start,
                                                   double end,
                                                   java.util.List<java.lang.Integer> weekdays,
                                                   double percentage)
                                                     throws java.rmi.RemoteException

      Adjust forecast data values for requested target by given percentage.
      Parameters:
        `scenarioId` - Scenario identifier, 0 - for master
        `BUIDArray` - Array of Business Unit IDs
        `siteIDArray` - Array of Site IDs
        `activities` - Array of forecast Activities
        `types` - Array of required data types
        `start` - Date range start
        `end` - Date range end
        `weekdays` - Days of week to include, empty - all days included.
        `percentage` - Data change percentage: 0-99% is a decreased value, 100% no change, and 101+% is an increased value.
      Returns:
        Async request ID
      Throws:
        `java.rmi.RemoteException`

    - #### deleteScenario

          void deleteScenario(int scenarioId)
                              throws java.rmi.RemoteException

      Deletes specified scenario information and related Activities information.
      Parameters:
        `scenarioId` - Scenario identifier
      Throws:
        `java.rmi.RemoteException`

    - #### deleteForecastInformation

          void deleteForecastInformation(int scenarioId,
                                       java.util.List<FrcActivity> activities,
                                       double start,
                                       double end)
                                         throws java.rmi.RemoteException

      Deletes specified scenario Activities information for requested date range.
      Parameters:
        `scenarioId` - Scenario identifier
        `activities` - Involved scenario's Activities
        `start` - Date range start
        `end` - Date range end
      Throws:
        `java.rmi.RemoteException`

    - #### publishForecast

          java.lang.String publishForecast(java.util.List<FrcActivity> activities,
                                         int sourceScenarioId,
                                         double sourceStartDate,
                                         double sourceEndDate,
                                         int targetScenarioId,
                                         double targetStartDate,
                                         double targetEndDate)
                                           throws java.rmi.RemoteException

      Publishes requested Activity forecast information from the forecast scenario to the master forecast, or from the master to the forecast scenario, or from one forecast scenario to another forecast scenario.
      Parameters:
        `activities` - Source scenario's Activities. If empty - means all source Activities.
        `sourceScenarioId` - ID of the source forecast. 0 - for Master.
        `sourceStartDate` - Source date range start
        `sourceEndDate` - Source date range end
        `targetScenarioId` - ID of the target forecast. 0 - for Master.
        `targetStartDate` - Target date range start
        `targetEndDate` - Target date range end
      Returns:
        Asynchronous request ID
      Throws:
        `java.rmi.RemoteException`

    - #### publishSelectedForecast

          java.lang.String publishSelectedForecast(java.util.List<FrcActivity> activities,
                                                 int sourceScenarioID,
                                                 double sourceStartDate,
                                                 double sourceEndDate,
                                                 int targetScenarioID,
                                                 double targetStartDate,
                                                 double targetEndDate,
                                                 java.util.List<java.lang.Integer> selectedForecastCategories)
                                                   throws java.rmi.RemoteException

      Publishes requested Activity selected categories forecast information from the forecast scenario to the master forecast, or from the master to the forecast scenario, or from one forecast scenario to another forecast scenario.
      Parameters:
        `activities` - Source scenario's Activities. If empty - means all source Activities.
        `sourceScenarioID` - ID of the source forecast. 0 - for Master.
        `sourceStartDate` - Source date range start
        `sourceEndDate` - Source date range end
        `targetScenarioID` - ID of the target forecast. 0 - for Master.
        `targetStartDate` - Target date range start
        `targetEndDate` - Target date range end
        `selectedForecastCategories` - Categories (IDs) to be published. Supported: 50020 - for All Forecast data; 50022 - Interaction Volume; 50024 - Average Handle Time; 50026 - Staffing and Overheads.
      Returns:
        Asynchronous request ID
      Throws:
        `java.rmi.RemoteException`

    - #### getOverlays

          java.util.List<FrcOverlay> getOverlays(java.util.List<java.lang.Integer> BUIDArray,
                                               java.util.List<java.lang.Integer> siteIDArray,
                                               java.util.List<java.lang.Integer> overlayIDArray,
                                               double start,
                                               double end,
                                               boolean includeEvents,
                                               boolean includeActivities)
                                                 throws java.rmi.RemoteException

      Returns array of requested overlays (and events, activities is requested) for specified period.
      Parameters:
        `BUIDArray` - BU IDs, null means all BUs
        `siteIDArray` - Site IDs, null means all Sites
        `overlayIDArray` - Overlay IDs, null means all overlays
        `start` - Period start date, null means period is not applicable.
        `end` - Period end date, null means period is not applicable.
        `includeEvents` - Request to include overlay events.
        `includeActivities` - Request to include overlay activities.
      Returns:
        Target overlays (and events, activities).
      Throws:
        `java.rmi.RemoteException`

    - #### createOverlay

          void createOverlay(FrcOverlay overlay)
                             throws java.rmi.RemoteException

      Creates overlay with provided data.
      Parameters:
        `overlay` - Overlay data.
      Throws:
        `java.rmi.RemoteException`

    - #### editOverlay

          void editOverlay(FrcOverlay overlay)
                           throws java.rmi.RemoteException

      Updates existing overlay with provided data.
      Parameters:
        `overlay` - Updated overlay data
      Throws:
        `java.rmi.RemoteException`

    - #### deleteOverlay

          void deleteOverlay(int overlayID)
                             throws java.rmi.RemoteException

      Deletes specified overlay (and all related events, overlay activities).
      Parameters:
        `overlayID` - Overlay ID
      Throws:
        `java.rmi.RemoteException`

    - #### createOverlayEvent

          void createOverlayEvent(FrcOverlayEvent event)
                                  throws java.rmi.RemoteException

      Creates (overlay) event with provided attributes.
      Parameters:
        `event` - Overlay event
      Throws:
        `java.rmi.RemoteException`

    - #### editOverlayEvent

          void editOverlayEvent(FrcOverlayEvent event)
                                throws java.rmi.RemoteException

      Updates attributes of specified (overlay) event.
      Parameters:
        `event` - Overlay event
      Throws:
        `java.rmi.RemoteException`

    - #### deleteOverlayEvent

          void deleteOverlayEvent(int eventID)
                                  throws java.rmi.RemoteException

      Deletes specified (overlay) event.
      Parameters:
        `eventID` - Event ID
      Throws:
        `java.rmi.RemoteException`

    - #### getActivityOverlays

          java.util.List<FrcActivityOverlay> getActivityOverlays(java.util.List<FrcActivity> activities,
                                                               double start,
                                                               double end)
                                                                 throws java.rmi.RemoteException

      Returns array of overlays and events assigned to Activity(ies) for the specified period.
      Parameters:
        `activities` - Activity information
        `start` - Period start date, null means not applicable
        `end` - Period end date, null means not applicable
      Returns:
        Activity overlays and events. Contains an array of Activities if the request is for a Multi-site Activity or multiple Activities.
      Throws:
        `java.rmi.RemoteException`

    - #### getActivityOverlaysEx

          java.util.List<FrcActivityOverlay> getActivityOverlaysEx(java.util.List<FrcActivity> activities,
                                                                 double start,
                                                                 double end)
                                                                   throws java.rmi.RemoteException

      Returns array of overlays and events assigned to all specified Activity(ies) for specified period.
      Parameters:
        `activities` - Activity information
        `start` - Period start date, null means not applicable
        `end` - Period end date, null means not applicable
      Returns:
        Activity overlays and events. Contains an array of Activities if the request is for a Multi-site Activity or multiple Activities.
      Throws:
        `java.rmi.RemoteException`

    - #### getForecastActivityEvents

          java.util.List<FrcActivityEvents> getForecastActivityEvents(int scenarioId,
                                                                    java.util.List<FrcActivity> activities,
                                                                    double start,
                                                                    double end)
                                                                      throws java.rmi.RemoteException

      Returns forecast Activity events for specified period. Events stored for specific period, and has specified impact start date. Requested period can overlap with several periods, and service will return data for all involved events.
      Parameters:
        `scenarioId` - Scenario's identifier
        `activities` - Activities array
        `start` - Requested start date, null means not applicable
        `end` - Requested end date, null means not applicable
      Returns:
        Events in specified period
      Throws:
        `java.rmi.RemoteException`

    - #### getForecastActivityEventsEx

          java.util.List<FrcActivityEvents> getForecastActivityEventsEx(int scenarioId,
                                                                      java.util.List<FrcActivity> activities,
                                                                      double start,
                                                                      double end)
                                                                        throws java.rmi.RemoteException

      Returns forecast events for the specified period which is associated with all specified Activities.
      Parameters:
        `scenarioId` - Scenario-s identifier
        `activities` - Activities array
        `start` - Requested start date, null means not applicable
        `end` - Requested end date, null means not applicable
      Returns:
        Events associated with activities in specified period
      Throws:
        `java.rmi.RemoteException`

    - #### getForecastTargetEvents

          java.util.List<FrcActivityEventsEx> getForecastTargetEvents(int scenarioId,
                                                                    int target,
                                                                    int targetId,
                                                                    double start,
                                                                    double end)
                                                                      throws java.rmi.RemoteException

      Returns forecast events for the specified period which is associated with the specified target.
      Parameters:
        `scenarioId` - Scenario's identifier
        `target` - Target level
        `targetId` - Target identifier
        `start` - Requested start date, null means not applicable
        `end` - Requested end date, null means not applicable
      Returns:
        Events associated with activities in specified period
      Throws:
        `java.rmi.RemoteException`

    - #### buildPredictedDataUseMethod

          java.lang.String buildPredictedDataUseMethod(int scenarioId,
                                                     java.util.List<FrcActivity> activities,
                                                     java.util.List<java.lang.Integer> types,
                                                     double start,
                                                     double end,
                                                     int method,
                                                     double historyStart,
                                                     double historyEnd,
                                                     double growthRate,
                                                     java.util.List<FrcTemplateData> data,
                                                     java.util.List<FrcActivityEvents> eventsArray,
                                                     boolean frcSaveBuildResults,
                                                     boolean useAllEvents)
                                                       throws java.rmi.RemoteException

      Method takes the specified parameters and uses a method from the WFM Prediction Library to create data in the specified date range for the requested data types. It saves the data in the specified scenario and return request identifier (asynchronous).
      Parameters:
        `scenarioId` - Scenario identifier
        `activities` - Scenario Activities data to be built
        `types` - Array of required data types (IV and AHT supported)
        `start` - Requested start date
        `end` - Requested end date
        `method` - Method to be used (3, 4 supported)
        `historyStart` - Historical data start date
        `historyEnd` - Historical data start date
        `growthRate` - Used to adjust historical data, if any, and template values. 0 - do not use.
        `data` - Array contains data values for items (IV overlap, AHT overlap from FrcTemplateTypes) from periods when historical data should be overridden.
        `eventsArray` - Involved Events
        `frcSaveBuildResults` - true - save build results to DB; false - results not saved (additional action required)
        `useAllEvents` - Ignores events parameter and uses all applicable events
      Returns:
        Request identifier
      Throws:
        `java.rmi.RemoteException`

    - #### buildPredictedDataUseMethodWithHistoricalPeriods

          java.lang.String buildPredictedDataUseMethodWithHistoricalPeriods(int scenarioId,
                                                                          java.util.List<FrcActivity> activities,
                                                                          java.util.List<java.lang.Integer> types,
                                                                          double start,
                                                                          double end,
                                                                          int method,
                                                                          java.util.List<FrcInformationPeriod> periodsArray,
                                                                          double growthRate,
                                                                          java.util.List<FrcTemplateData> data,
                                                                          java.util.List<FrcActivityEvents> eventsArray,
                                                                          boolean frcSaveBuildResults,
                                                                          boolean useAllEvents)
                                                                            throws java.rmi.RemoteException

      Parameters:
        `scenarioId` -
        `activities` -
        `types` -
        `start` -
        `end` -
        `method` -
        `periodsArray` -
        `growthRate` -
        `data` -
        `eventsArray` -
        `frcSaveBuildResults` -
        `useAllEvents` -
      Returns:
        Request identifier
      Throws:
        `java.rmi.RemoteException`

    - #### buildPredictedDataBasedOnTemplate

          java.lang.String buildPredictedDataBasedOnTemplate(int scenarioId,
                                                           java.util.List<FrcActivity> activities,
                                                           java.util.List<java.lang.Integer> types,
                                                           double start,
                                                           double end,
                                                           double growthRate,
                                                           java.util.List<FrcTemplateData> templateData,
                                                           boolean frcSaveBuildResults)
                                                             throws java.rmi.RemoteException

      Method takes specified values (usually a combination of values from templates) and fills in corresponding periods (template values are provided for weekdays, not specific dates) in the specified date range for requested data types. It then saves data in the specified scenario and returns the request identifier used to retrieve results on completion (asynchronous).
      Parameters:
        `scenarioId` - Scenario identifier
        `activities` - Scenario Activities data to be built
        `types` - Array of required data types (IV and AHT types are supported)
        `start` - Requested start date
        `end` - Requested end date
        `growthRate` - Used to adjust (if any) template values. 0 - do not use.
        `templateData` - Array contains data values for item (IV, AHT types from FrcTemplateTypes). Data can be combined from several same type templates.
        `frcSaveBuildResults` - true - save build results to DB; false - results not saved (additional action required)
      Returns:
        Request identifier
      Throws:
        `java.rmi.RemoteException`

    - #### buildPredictedDataBasedOnConstant

          java.lang.String buildPredictedDataBasedOnConstant(int scenarioId,
                                                           java.util.List<FrcActivity> activities,
                                                           java.util.List<java.lang.Integer> types,
                                                           double start,
                                                           double end,
                                                           double growthRate,
                                                           double IVValue,
                                                           double AHTValue,
                                                           boolean frcSaveBuildResults)
                                                             throws java.rmi.RemoteException

      Method takes specified value and fills in all periods in the specified date range for the requested data types. It then saves data in the specified scenario and returns the request identifier used to retrieve results on completion (asynchronous).
      Parameters:
        `scenarioId` - Scenario identifier
        `activities` - Scenario Activities data to be built
        `types` - Array of required data types (IV and AHT types supported)
        `start` - Requested start date
        `end` - Requested end date
        `growthRate` - Used to adjust values. 0 - do not use.
        `IVValue` - Constant Interaction Volume value to be assigned
        `AHTValue` - Constant Average Handle Time value to be assigned
        `frcSaveBuildResults` - true - save build results to DB; false - results not saved (additional action required)
      Returns:
        Request identifier
      Throws:
        `java.rmi.RemoteException`

    - #### buildPredictedDataBasedOnHistory

          java.lang.String buildPredictedDataBasedOnHistory(int scenarioId,
                                                          java.util.List<FrcActivity> activities,
                                                          java.util.List<java.lang.Integer> types,
                                                          double start,
                                                          double end,
                                                          double historyStart,
                                                          double historyEnd,
                                                          double growthRate,
                                                          java.util.List<FrcTemplateData> overrideData,
                                                          boolean frcSaveBuildResults)
                                                            throws java.rmi.RemoteException

      Method takes specified values (historical data or data overridden by specified values) and fills in corresponding periods (template values or provided specific dates) in specified date range for the requested data types. It then saves the data in the specified scenario and, on completion, returns the request identifier used to retrieve the results (asynchronous).
      Parameters:
        `scenarioId` - Scenario identifier
        `activities` - Scenario Activities data to be built
        `types` - Array of required data types (IV and AHT types are supported)
        `start` - Requested start date
        `end` - Requested end date
        `historyStart` - Historical data start date
        `historyEnd` - Historical data end date
        `growthRate` - Used to adjust historical data, if any, and template values, 0 - do not use.
        `overrideData` - Array contains data values for item (IV overlap, AHT overlap types from FrcTemplatesTypes) for periods when historical data should be overridden.
        `frcSaveBuildResults` - true - save build results to DB; false - results not saved (additional action required)
      Returns:
        Request identifier
      Throws:
        `java.rmi.RemoteException`

    - #### asyncSplitPredictedData

          java.lang.String asyncSplitPredictedData(int scenarioId,
                                                 java.util.List<FrcActivity> sourceActivity,
                                                 java.util.List<FrcActivity> targetActivities,
                                                 double start,
                                                 double end,
                                                 java.util.List<FrcActivityPeriodParameters> periodParameters,
                                                 boolean keepAHT,
                                                 boolean useAllActivities,
                                                 boolean frcSaveSplitResults,
                                                 boolean considerPlannedItems)
                                                   throws java.rmi.RemoteException

      Method takes specified source Multi-site Activities Interaction Volume (and Average Handle Time, if the parameter is specified) data and splits using [splitting] algorithm between specified Activities for the specified date range. It then saves the data for the specified scenario. Multi-site Activity data can be split between any number of Activities associated with the Multi-site Activity. Returned request identifier used to retrieve results on completion (asynchronous).
      Parameters:
        `scenarioId` - Scenario identifier
        `sourceActivity` - Scenario Multi-Site Activities used as data source
        `targetActivities` - Scenario Activities (data split target)
        `start` - Requested start date
        `end` - Requested end date
        `periodParameters` - Period and basic parameters for target Activities
        `keepAHT` - true - keep original Activity AHT; false - use MS Activity AHT (split AHT too)
        `useAllActivities` - true - use all scenario activities to split data; false - use just activities associated with the virtual activity
        `frcSaveSplitResults` - true - save split results to DB; false - results not saved (additional action required)
        `considerPlannedItems` - true - splitting will consider pre-planned granted Calendar items
      Returns:
        Request identifier
      Throws:
        `java.rmi.RemoteException`

    - #### splitInteractionVolume

          java.lang.String splitInteractionVolume(int scenarioID,
                                                java.util.List<FrcActivity> sourceActivity,
                                                java.util.List<FrcActivity> targetActivities,
                                                double start,
                                                double end,
                                                java.util.List<FrcActivityPeriodParameters> periodParameters,
                                                boolean keepAHT,
                                                boolean useAllActivities,
                                                boolean frcSaveSplitResults,
                                                boolean considerPlannedItems,
                                                java.util.List<FrcActivityPercentageParameters> percentageParameters)
                                                  throws java.rmi.RemoteException

      Method takes specified source Multi-site Activities Interaction Volume (and Average Handle Time, if the parameter is specified) data and splits using [splitting] algorithm between specified Activities for the specified date range. This method also allows to specify percenatges of volume to be split for each Activity. It then saves the data for the specified scenario. Multi-site Activity data can be split between any number of Activities associated with the Multi-site Activity. Returned request identifier used to retrieve results on completion (asynchronous).
      Parameters:
        `scenarioID` - Scenario identifier
        `sourceActivity` - Scenario Multi-Site Activities used as data source
        `targetActivities` - Scenario Activities (data split target)
        `start` - Requested start date
        `end` - Requested end date
        `periodParameters` - Period and basic parameters for target Activities
        `keepAHT` - true - keep original Activity AHT; false - use MS Activity AHT (split AHT too)
        `useAllActivities` - true - use all scenario activities to split data; false - use just activities associated with the virtual activity
        `frcSaveSplitResults` - true - save split results to DB; false - results not saved (additional action required)
        `considerPlannedItems` - true - splitting will consider pre-planned granted Calendar items
        `percentageParameters` - Percentage of Volume for each Activity to be assigned, can be empty
      Returns:
        Request identifier
      Throws:
        `java.rmi.RemoteException`

    - #### splitStaffingDataAsync

          java.lang.String splitStaffingDataAsync(int scenarioId,
                                                java.util.List<FrcActivity> sourceActivity,
                                                java.util.List<FrcActivity> targetActivities,
                                                double start,
                                                double end,
                                                java.util.List<FrcActivityPeriodParameters> periodParameters,
                                                java.util.List<FrcActivityStaffingDataParameters> parametersArray,
                                                boolean splitRequired,
                                                boolean useAHT,
                                                boolean frcSaveSplitResults)
                                                  throws java.rmi.RemoteException

      Method takes specified source Multi-site Activities Calculated Staffing requirements (and Required if the parameter is specified) data and splits using [splitting] algorithm between specified Activities for the specified date range. It then saves data for the specified scenario. Multi-site Activity data can be split between any number of Activities associated with the Multi-site Activity.
      Parameters:
        `scenarioId` - Scenario identifier
        `sourceActivity` - Scenario Multi-Site Activities used as data source
        `targetActivities` - Scenario Activities (data split target)
        `start` - Requested start date
        `end` - Requested end date
        `periodParameters` - Period and basic parameters for target Activities
        `parametersArray` - IOT and overheads for target Activities
        `splitRequired` - true - also split Required Staffing using the same settings
        `useAHT` - true - use MS Activity child Activities AHT; false - use MS Activity AHT
        `frcSaveSplitResults` - true - save split results to DB; false - results not saved (additional action required)
      Returns:
        Request identifier
      Throws:
        `java.rmi.RemoteException`

    - #### calculateStaffingRequirementData

          java.lang.String calculateStaffingRequirementData(int scenarioId,
                                                          java.util.List<FrcActivity> targetActivities,
                                                          java.util.List<java.lang.Integer> types,
                                                          double start,
                                                          double end,
                                                          int method,
                                                          java.util.List<FrcActivityPeriodParameters> periodParameters,
                                                          java.util.List<FrcActivityStaffingDataParameters> parametersArray,
                                                          java.util.List<FrcActivityStaffingDataObjectives> objectivesArray,
                                                          java.util.List<FrcActivityTemplateData> templateDataArray,
                                                          java.util.List<java.lang.Integer> groupIDArray,
                                                          boolean frcSaveBuildResults)
                                                            throws java.rmi.RemoteException

      Method takes Activity parameters according to method used to calculate data in the specified date range for requested data types, and saves data for the specified scenario and return request identifier (asynchronous). IV and AHT data (predicted data) must be present to calculate Staffing requirements. Parameters used depend on method: 0 - start, end, fixedAgents or fixedAHT from FrcActivityPeriodParameters; 2 - start, end, templateData; 5 - start, end, serviceTime, abandonTime from FrcActivityPeriodParameters, FrcActivityStaffingDataParameters, FrcActivityStaffingDataObjectives; 6 - start, end, IOT from FrcActivityStaffingDataParameters.
      Parameters:
        `scenarioId` - Scenario identifier
        `targetActivities` - Scenario Activities data to be built
        `types` - Array of required data types (Calculated and Required Staffing supported)
        `start` - Requested start date
        `end` - Requested end date
        `method` - Types 0, 2, 5 and 6 supported.
        `periodParameters` - Period and basic parameters
        `parametersArray` - IOT and overheads
        `objectivesArray` - Service Objectives
        `templateDataArray` - Contains data values for item (Staffing type from FrcTemplatesTypes). Data can be combined from several templates.
        `groupIDArray` - Array of Schedule State Group IDs.
        `frcSaveBuildResults` - true - save build results to DB, false - results not saved (additional action required)
      Returns:
        Request identifier
      Throws:
        `java.rmi.RemoteException`

    - #### getHistoricalShortInformation

          FrcHistoricalShortInformation getHistoricalShortInformation()
                                                                      throws java.rmi.RemoteException

      Returns basic historical data (start/end, Activities).
      Returns:
        Basic Historical data
      Throws:
        `java.rmi.RemoteException`

    - #### getActivityHistoricalInformationIndicators

          java.util.List<FrcActivityHistoricalInformationIndicators> getActivityHistoricalInformationIndicators(java.util.List<FrcActivity> activities,
                                                                                                              java.util.List<java.lang.Integer> types,
                                                                                                              double start,
                                                                                                              double end,
                                                                                                              int request)
                                                                                                                throws java.rmi.RemoteException

      Returns historical data indicators for requested Activities and historical data date ranges for specified period.
      Parameters:
        `activities` - Required Activities
        `types` - Required information types: IV or/and AHT
        `start` - Requested start date
        `end` - Requested end date
        `request` - 0 - only historical data earliest and latest dates (min/max); 1 - historical data min/max dates and date ranges for the specified period
      Returns:
        Activity historical data indicators (dates)
      Throws:
        `java.rmi.RemoteException`

    - #### getHistoricalInformation

          java.util.List<FrcTargetForecastInformation> getHistoricalInformation(int target,
                                                                              int targetId,
                                                                              java.util.List<java.lang.Integer> types,
                                                                              double start,
                                                                              double end,
                                                                              int granularity)
                                                                                throws java.rmi.RemoteException

      Returns historical data for specified period and specified Activities. Granularity parameter determines what periods should be returned. Service performs aggregation on data.
      Parameters:
        `target` - Target level
        `targetId` - Requested target identifier
        `types` - Array of required types (IV and/or AHT supported)
        `start` - Requested start date
        `end` - Requested end date
        `granularity` - Requested period of granularity, in minutes. Period data aggregated from the start to the end, according to the given granularity. Meaningful values: 0 - total for the whole period; 15 min (time step); 1440 (1 day); 10080 (1 week); 60480 (max long period - 6 weeks). Monthly aggregation performed on calendar-month basis (special value is -1), e.g. starting Jun 15, 2003, and ending Jul 15, 2003, aggregates as 2 values for the periods: Jun 15, 2003, to Jun 30, 2003, and Jul 1, 2003,to Jul 15, 2003. Special values: 0 - for total value; -1 - calendar month; -10 - calendar week starts Sunday; -11 - calendar week starts Mon.; -12 - calendar week starts Tue.; -13 - calendar week starts Wed.; -14 - calendar week starts Thu.; -15 - calendar week starts Fri.; -16 - calendar week starts Sat.
      Returns:
        Contains requested information values related to the target
      Throws:
        `java.rmi.RemoteException`

    - #### getTemplatesList

          java.util.List<FrcTemplateHeader> getTemplatesList(java.util.List<java.lang.Integer> BUs,
                                                           java.util.List<java.lang.Integer> sites,
                                                           java.util.List<java.lang.Integer> types)
                                                             throws java.rmi.RemoteException

      Returns all templates for the specified target. Template headers have basic template information and the template Activities' identifiers. Forecast service can return only the requested types (filter by type) of templates.
      Parameters:
        `BUs` - Array of Business Units identifiers: if empty, and the sites array is empty as well, the service returns all templates of the specified types.
        `sites` - Array of Site identifiers: if empty, and the BUs array is empty as well, the service returns all templates of the specified types.
        `types` - Array of required template types: if empty, service returns all.
      Returns:
        Contains list of templates
      Throws:
        `java.rmi.RemoteException`

    - #### getTemplatesListEx

          java.util.List<FrcTemplateHeader> getTemplatesListEx(java.util.List<java.lang.Integer> BUs,
                                                             java.util.List<java.lang.Integer> sites,
                                                             java.util.List<java.lang.Integer> types,
                                                             java.util.List<FrcActivity> activities)
                                                               throws java.rmi.RemoteException

      Returns templates associated with specified Activities. Template headers have basic template information and template Activities' identifiers. Forecast service can return only the requested types (filter by type) of templates.
      Parameters:
        `BUs` - Array of Business Units identifiers
        `sites` - Array of Site identifiers
        `types` - Array of required template types: if empty, the service returns all types.
        `activities` - Activity filter: if array is empty, then this method works as method getTemplateList does.
      Returns:
        Contains list of templates
      Throws:
        `java.rmi.RemoteException`

    - #### getTemplateData

          java.util.List<FrcData> getTemplateData(int templateId)
                                                  throws java.rmi.RemoteException

      Returns template's data values.
      Parameters:
        `templateId` - Template's identifier
      Returns:
        Contains list of data values
      Throws:
        `java.rmi.RemoteException`

    - #### getTemplate

          FrcTemplate getTemplate(int templateId,
                                int request)
                                  throws java.rmi.RemoteException

      Returns template's header, activities, and data values.
      Parameters:
        `templateId` - Template's identifier
        `request` - Request mask: 0 - all data; 1 - header only; 2 - activities only; 4 - data only. Combinations accepted, e.g. 5 for template header and data request.
      Returns:
        Contains template header, activities, and data values
      Throws:
        `java.rmi.RemoteException`

    - #### getTemplateActivities

          java.util.List<FrcActivity> getTemplateActivities(int templateId)
                                                            throws java.rmi.RemoteException

      Returns all template's Activities.
      Parameters:
        `templateId` - Template's identifier
      Returns:
        Contains list of Activities
      Throws:
        `java.rmi.RemoteException`

    - #### createTemplate

          int createTemplate(int type,
                           java.lang.String name,
                           int parentType,
                           int parentId,
                           double start,
                           double end,
                           java.util.List<FrcActivity> activities,
                           double initialValue,
                           int basedOnTemplate)
                             throws java.rmi.RemoteException

      Creates new template under "parent". Associates with specified Activities, and either sets all values to the specified initial value, or copies values from the "base" template. Overlap templates are created for the specified start, end period, and other, for one week.
      Parameters:
        `type` - Template's type
        `name` - Template's name (cannot be empty)
        `parentType` - Site or BU
        `parentId` - Site or BU identifier
        `start` - Start date of the template data (obsolete for non-overlap templates)
        `end` - End date of the template data (obsolete for non-overlap-templates)
        `activities` - Array of associated Activities
        `initialValue` - Initial value for all Activities and all time steps (-1 to be ignored)
        `basedOnTemplate` - "Base" template identifier (-1 to be ignored). "based on" template must be of the same type as the template itself.
      Returns:
        Template's identifier
      Throws:
        `java.rmi.RemoteException`

    - #### setTemplateName

          void setTemplateName(int templateId,
                             java.lang.String name)
                               throws java.rmi.RemoteException

      Modifies existing template's name.
      Parameters:
        `templateId` - Template's identifier
        `name` - Template's name
      Throws:
        `java.rmi.RemoteException`

    - #### setTemplateData

          void setTemplateData(int templateId,
                             java.util.List<FrcData> data)
                               throws java.rmi.RemoteException

      Modifies existing template and sets specified values for periods.
      Parameters:
        `templateId` - Template's identifier
        `data` - Contains list of data values
      Throws:
        `java.rmi.RemoteException`

    - #### deleteTemplate

          void deleteTemplate(java.util.List<java.lang.Integer> templates)
                              throws java.rmi.RemoteException

      Deletes all specified templates.
      Parameters:
        `templates` - Template to be deleted identifiers
      Throws:
        `java.rmi.RemoteException`

    - #### addTemplateActivities

          void addTemplateActivities(int templateId,
                                   java.util.List<FrcActivity> activities)
                                     throws java.rmi.RemoteException

      Method modifies existing template and adds specified Activities.
      Parameters:
        `templateId` - Template's identifier
        `activities` - Contains list of Activities
      Throws:
        `java.rmi.RemoteException`

    - #### deleteTemplateActivities

          void deleteTemplateActivities(int templateId,
                                      java.util.List<FrcActivity> activities)
                                        throws java.rmi.RemoteException

      Modifies existing template and removes specified Activities.
      Parameters:
        `templateId` - Template's identifier
        `activities` - Contains list of Activities
      Throws:
        `java.rmi.RemoteException`

    - #### saveHistoricalDataAsTemplate

          int saveHistoricalDataAsTemplate(int type,
                                         java.lang.String name,
                                         int parentType,
                                         int parentId,
                                         double start,
                                         double end,
                                         double templateStart,
                                         double templateEnd,
                                         java.util.List<FrcActivity> activities,
                                         java.util.List<FrcActivity> sourceActivities)
                                           throws java.rmi.RemoteException

      Saves historical Interaction Volume or Average Handle Time data as template. For overlap templates, saves specified date range; for non-overlap templates, starting from start, saves historical data to corresponding day of the week until all 7 days are filled, or until the specified end date is reached (all remaining days will be empty).
      Parameters:
        `type` - Template type (IV, AHT, IV overlap, AHT overlap are supported)
        `name` - Template's name
        `parentType` - Site or BU
        `parentId` - Template's parent identifier
        `start` - Source start date
        `end` - Source end date
        `templateStart` - Template start date, if null then same as source start date
        `templateEnd` - Template end date, if null then same as source end date
        `activities` - Activities to be associated with the new template
        `sourceActivities` - Source Activity identifiers (sourceActivities can be different from activities and used to retrieve data for the template.)
      Returns:
        Template's identifier
      Throws:
        `java.rmi.RemoteException`

    - #### saveStaffingDataAsTemplate

          int saveStaffingDataAsTemplate(java.lang.String name,
                                       int parentType,
                                       int parentId,
                                       double start,
                                       double end,
                                       java.util.List<FrcActivity> activities,
                                       int sourceScenarioId,
                                       java.util.List<FrcActivity> sourceActivities)
                                         throws java.rmi.RemoteException

      Saves specified scenario Activities Staffing requirements as template for requested Activities. Template type is "Staffing".
      Parameters:
        `name` - Template's name
        `parentType` - Site or BU
        `parentId` - Template's parent (Site or BU) identifier
        `start` - Source start date
        `end` - Source end date
        `activities` - Activities data to be associated with the new template. New template's Activities can differ from source Activities and can be from a different Site or BU. If more than one source Activity is specified, data is aggregated and then assigned to each template's Activity.
        `sourceScenarioId` - Source scenario identifier
        `sourceActivities` - Source Activity identifiers
      Returns:
        Template's identifier
      Throws:
        `java.rmi.RemoteException`

    - #### saveForecastRequestData

          java.lang.String saveForecastRequestData(java.lang.String asyncRequestToSaveID)
                                                   throws java.rmi.RemoteException

      Method should be used to save results of forecast build request.
      Parameters:
        `asyncRequestToSaveID` - Previous build request identifier
      Returns:
        Request identifier
      Throws:
        `java.rmi.RemoteException`

    - #### getForecastRequestActivityData

          java.util.List<FrcTargetForecastInformation> getForecastRequestActivityData(java.lang.String requestID,
                                                                                    int activityID,
                                                                                    java.util.List<java.lang.Integer> types,
                                                                                    double start,
                                                                                    double end,
                                                                                    int granularity)
                                                                                      throws java.rmi.RemoteException

      Method returns forecast results for the specified Activity, if request completed. No data is available if the request is in progress.
      Parameters:
        `requestID` - Request identifier
        `activityID` - Activity identifier
        `types` - Array of required types from FrcDataTypes
        `start` - Requested period start date
        `end` - Requested period end date
        `granularity` - Requested period's granularity, in minutes
      Returns:
        Contains requested information values related to the request Activity
      Throws:
        `java.rmi.RemoteException`

    - #### getForecastActivityPredictionBuildSelection

          FrcActivityBuildSelection getForecastActivityPredictionBuildSelection(int scenarioID,
                                                                              int target,
                                                                              int targetID)
                                                                                throws java.rmi.RemoteException

      Method returns the user selection made for the last predicted data build for the selected target (Activity or Multi-site Activity) in the scenario.
      Parameters:
        `scenarioID` - Scenario identifier
        `target` - Target level
        `targetID` - Activity/Multi-site Activity identifier
      Returns:
        Build selection
      Throws:
        `java.rmi.RemoteException`

    - #### getForecastActivityStaffingBuildSelection

          FrcActivityBuildSelection getForecastActivityStaffingBuildSelection(int scenarioID,
                                                                            int target,
                                                                            int targetID)
                                                                              throws java.rmi.RemoteException

      Method returns the user selection made for the last staffing requirements build for the selected target (Activity or Multi-site Activity) in the scenario.
      Parameters:
        `scenarioID` - Scenario identifier
        `target` - Target level
        `targetID` - Activity/Multi-site Activity identifier
      Returns:
        Build selection
      Throws:
        `java.rmi.RemoteException`

    - #### getScenarioActivityStateGroups

          java.util.List<FrcActivityStateGroup> getScenarioActivityStateGroups(int scenarioID,
                                                                             double start,
                                                                             double end,
                                                                             CfgActivityFilter activityFilter)

      Returns activity and state groups which have shrinkage data
      Parameters:
        `start` - Start date
        `end` - End date
        `scenarioID` - Forecast ID
        `activityFilter` - Specified activities
      Returns:
        Activity and state group array

    - #### deleteScenarioActivityStateGroups

          java.lang.String deleteScenarioActivityStateGroups(int scenarioID,
                                                           double start,
                                                           double end,
                                                           java.util.List<FrcActivityStateGroup> activityStateGroups)

      Delete activity and state group shrinkage data
      Parameters:
        `start` - Start date
        `end` - End date
        `scenarioID` - Forecast ID
        `activityStateGroups` - Activity and state group array
      Returns:
        Request ID

    - #### setForecastShrinkage

          java.lang.String setForecastShrinkage(int scenarioID,
                                              java.util.List<FrcShrinkageData> shrinkageDataArray)

      Sets shrinkage data for activity and state group
      Parameters:
        `shrinkageDataArray` - Activity and state group data
        `scenarioID` - Forecast ID
      Returns:
        Request ID

    - #### setOvertimeRequirement

          java.lang.String setOvertimeRequirement(java.util.List<FrcOvertimeData> overtimeDataArray)

      Sets overtime requirement for activity
      Parameters:
        `overtimeDataArray` - Activity(ies) overtime data array
      Returns:
        Request ID

    - #### copyScenarioActivityShrinkageData

          java.lang.String copyScenarioActivityShrinkageData(int scenarioID,
                                                           double start,
                                                           double end,
                                                           FrcActivityStateGroup sourceActivityStateGroup,
                                                           java.util.List<FrcActivityStateGroup> targetActivityStateGroups)

      Copies shrinkage data from source activity and state group to target activities and state groups
      Parameters:
        `start` - Start date
        `end` - End date
        `scenarioID` - Forecast ID
        `sourceActivityStateGroup` - Source Activity and state group
        `targetActivityStateGroups` - Target Activity and state group array
      Returns:
        Request ID

    - #### applyOverheadTemplate

          java.lang.String applyOverheadTemplate(int scenarioID,
                                               double start,
                                               double end,
                                               java.util.List<FrcActivityStateGroup> targetActivityStateGroups,
                                               java.util.List<java.lang.Integer> typeIDArray,
                                               java.util.List<FrcTemplateData> templateData)

      Applies existing template data to specified overhead for selected activity and state group
      Parameters:
        `templateData` - Template data to be applied
        `start` - Start date
        `end` - End date
        `scenarioID` - Forecast scenario ID
        `typeIDArray` - Overhead item types
        `targetActivityStateGroups` - Activity and state group array
      Returns:
        Request ID

    - #### setForecastPeriodParameters

          java.lang.String setForecastPeriodParameters(int scenarioID,
                                                     java.util.List<FrcActivityPeriodParameters> periodParameters)

      Sets forecast parameters for specified activity and period
      Parameters:
        `scenarioID` - Forecast scenario ID
        `periodParameters` - Forecast parameters (-1 for empty, will not change the existing value)
      Returns:
        Request ID

    - #### calculateInteractionQueue

          java.lang.String calculateInteractionQueue(int scenarioID,
                                                   double start,
                                                   double end,
                                                   CfgActivityFilter activityFilter,
                                                   double initialQueue)

      Parameters:
        `scenarioID` -
        `start` -
        `end` -
        `activityFilter` -
        `initialQueue` -
      Returns:
        Request ID

    - #### getUserHistoricalPeriods

          java.util.List<FrcInformationPeriod> getUserHistoricalPeriods(int scenarioID)

      Parameters:
        `scenarioID` -
      Returns:
        User historical periods

Copyright © 2005-2016 Genesys Telecommunications Labs, Inc. All Rights Reserved.